#include "arctic.h"

#include <string.h>

int arctic_max_expanded_size(int compressed_size) {
    /* at most every 6th byte is free */
    return (6 * compressed_size) / 5 + 1;
}

int arctic_max_compressed_size(int expanded_size) {
    return (5 * expanded_size) / 6 + 1;
}

void arctic_expand(char *expanded, const char *compressed) {
    // TODO
}

void arctic_compress(char *compressed, const char *expanded) {
    // TODO
}

static const char *parse_immediate(const char *expanded, struct ArcticOperation *op) {
    return expanded; // TODO
}

void arctic_normalize(struct ArcticOperation *ops, const char *expanded) {
    const char *o = expanded;
    struct ArcticOperation *op = ops;

    *op = (struct ArcticOperation){ 0 };

    while (*o) {
        int opcode = *o++;

        switch (*o) {
            /* ops with an immediate */
            case '0': case 'G': case 'H': case 'L': case 'M': case 'P':
            case 'Q': case 'd': case 'o': case 'u': case '<': case '{':
            case '=': case '}': case '>': case ',': case ';': case '[':
            case ']': case '"':
                o = parse_immediate(o, op);

            /* ops without an immediate */
            case '1': case '2': case '3': case '4': case '5': case '6':
            case '7': case '8': case '9': case 'A': case 'B': case 'C':
            case 'D': case 'E': case 'F': case 'I': case 'J': case 'K':
            case 'N': case 'O': case 'R': case 'S': case 'U': case 'V':
            case 'W': case 'X': case 'Y': case 'Z': case 'a': case 'b':
            case 'c': case 'e': case 'f': case 'g': case 'h': case 'i':
            case 'j': case 'k': case 'l': case 'm': case 'n': case 'p':
            case 'q': case 'r': case 's': case 't': case 'v': case 'w':
            case 'x': case 'y': case 'z': case '_': case '.': case '+':
            case '-': case '*': case '/': case '%': case '\\': case '|':
            case '&': case '^': case '!': case '?': case '(': case ')':
                op->opcode = opcode;
                *++op = (struct ArcticOperation){ 0 };
                break;

            /* unusual ops */
            case '$': case '@': case ':': case '`': case ' ': case '\n':
            case '\'':

            default: /* non-active characters */
                break;
        }
    }
}
